// TYPE: C
// PRJ: JCL
// PGM: Jiro_String
// VER: 2.00
// USES: CodeWarrior, Xcode, Visual C++ 6.0-8.0, JCL
// CREATE: 1999/02/21( Siratori )
// UPDATE: 1999/10/01( Siratori )
// UPDATE: 2003/04/09( tsunoda )
// UPDATE: 2005/03/15( hisa )
// UPDATE: 2007/02/20( hisa, igari )
// UPDATE: 2007/08/28( tamura )
// UPDATE: 2008/06/06( tamura, sugimoto )
// UPDATE: 2009/05/13( hisa )
// UPDATE: 2009/08/18( hisa )
// UPDATE: 2009/07/30( hisa )
/////////////////////////////////////////////////////
#ifndef __JIRO_STRINGS__
#define __JIRO_STRINGS__

#ifdef __cplusplus
extern "C" {
#endif
	
//***********************************************************
// 外部関数のプロトタイプ宣言
//***********************************************************
//-------------------------------------------------------------
// 関数 : Jiro_Pstrcpy
// 機能 : パスカル文字列コピー
//-------------------------------------------------------------
void Jiro_Pstrcpy( unsigned char* outDestStr, unsigned char* inSrcStr );

//-------------------------------------------------------------
// 関数 : Jiro_Pstrcat
// 機能 : パスカル文字列連結
//-------------------------------------------------------------
void Jiro_Pstrcat( unsigned char* ioStr, unsigned char* inAddStr );

//-------------------------------------------------------------
// 関数 : Jiro_Cstr2Pstr
// 機能 : Ｃ文字列をパスカル文字列に変換
//-------------------------------------------------------------
void Jiro_Cstr2Pstr( unsigned char* outDestStr, char* inSrcStr );

//-------------------------------------------------------------
// 関数 : Jiro_Pstr2Cstr
// 機能 : パスカル文字列をＣ文字列に変換
//-------------------------------------------------------------
void Jiro_Pstr2Cstr( char* outDestStr, unsigned char* inSrcStr );

//-------------------------------------------------------------
// 関数 : Jiro_CutStringLength
// 機能 : 文字列長を指定された長さでカット
//-------------------------------------------------------------
void Jiro_CutStringLength( char* ioStr, long inLength );

//-------------------------------------------------------------
// 関数 : Jiro_GetCharAttr
// 機能 : 文字の属性を取得
// 戻り値： 0：半角、１：全角の１バイト目、２：全角の２バイト目
// 1999.10.1-1 add
//-------------------------------------------------------------
short Jiro_GetCharAttr( unsigned char* ioStr, long nOff );

//-------------------------------------------------------------
// 関数 : Jiro_IsZenkaku1
// 機能 : 全角文字の１バイト目？
//-------------------------------------------------------------
bool Jiro_IsZenkaku1( unsigned char inCh );

//-------------------------------------------------------------
// 関数 : Jiro_IsZenkaku2
// 機能 : 全角文字の２バイト目？
// 戻値： true（全角文字の２バイト目）、false（全角文字の２バイト目ではない）
//-------------------------------------------------------------
bool Jiro_IsZenkaku2( unsigned char inCh );

//-------------------------------------------------------------
// 関数 : Jiro_IsNumberStr
// 機能 : 数値文字列？
// 戻値 : true（数値文字列）、false（数値文字列ではない）
//-------------------------------------------------------------
bool Jiro_IsNumberStr( char* inStr );

//-------------------------------------------------------------
// 関数 : Jiro_IsNumOrPeriodStr
// 機能 : 数値またはピリオドの文字列？
// 戻値 : true（数値文字列）、false（数値文字列ではない）
//-------------------------------------------------------------
bool Jiro_IsNumOrPeriodStr( char* inStr );

//-------------------------------------------------------------
// 関数 : Jiro_LongToCommaString
// 機能 : 数値をコンマ付の文字列に変換
//-------------------------------------------------------------
void Jiro_LongToCommaString( long inNum, char* outDestStr );

//-------------------------------------------------------------
// 関数 : Jiro_NumStrToCommaStr
// 機能 : 数値文字列をコンマ付の文字列に変換
//-------------------------------------------------------------
void Jiro_NumStrToCommaString( char* inSrcStr, char* outDestStr );

//-------------------------------------------------------------
// 関数 : Jiro_StripCharFromEnd
// 機能 : 文字列の後ろにある、指定文字を削除
//-------------------------------------------------------------
void Jiro_StripCharFromEnd( char* ioStr, char inDelCh );

//-------------------------------------------------------------
// 関数 : Jiro_StripCharFromStart
// 機能 : 文字列の先頭にある、指定文字を削除
//-------------------------------------------------------------
void Jiro_StripCharFromStart( char* ioStr, char inDelCh );

//-------------------------------------------------------------
// 関数 : Jiro_ReplaceString
// 機能 : 文字列の置換処理
//-------------------------------------------------------------
void Jiro_ReplaceString( char* ioTargetStr, const char* inFindStr, const char* inReplaceStr );

//-------------------------------------------------------------
// 関数 : Jiro_Num_To_2byteStr
// 機能 : 数字を全角文字列に変換
//-------------------------------------------------------------
void Jiro_Num_To_2byteStr( long inNum, char* outStr );

//-------------------------------------------------------------
// 関数 : Jiro_GetIndexOfLastChar
// 機能 : 全角の混じった文字列から指定した半角文字が最後に出てくるインデックスを返す
// add_tsunoda 030409
//-------------------------------------------------------------
long Jiro_GetIndexOfLastChar( const char* inStr, char inOffset );

//-------------------------------------------------------------
// 関数 : Jiro_IsTheSamedDouble
// 機能 : ２つのＤＯＵＢＬＥ型が一致？
// add_hisa 050315
//-------------------------------------------------------------
bool Jiro_IsTheSamedDouble( double inVal1, double inVal2 );

//-------------------------------------------------------------
// 関数 : Jiro_DoubleToChar
// 機能 : ＤＯＵＢＬＥ型を文字列型に変換( 小数点以下を考慮 )
// add_hisa 050315
//-------------------------------------------------------------
void Jiro_DoubleToChar( double inNumVal, char* outNumBuff );

//-------------------------------------------------------------
// 関数 : Jiro_Malloc
// 機能 : バッファを確保
// add_hisa 050315
//-------------------------------------------------------------
char* Jiro_Malloc( long inBuffSize );

//-------------------------------------------------------------
// 関数 : Jiro_MallocFree
// 機能 : バッファを解放
// add_hisa 050315
//-------------------------------------------------------------
void Jiro_MallocFree( void* inBuffer );

//-------------------------------------------------------------
// 関数： Jiro_GetViewDateStringFromDataChars
// 機能 : 日時を文字列に
// char inSourceChars[18]  // YYYYMMDDHHMMSS000
// char outDestStr[17]  // YYYY/MM/DD HH:MM
//			               01234567890123456
// add_igari 070220
//-------------------------------------------------------------
void Jiro_GetViewDateStringFromDataChars( char* inSourceChars, char* outDestStr );

//-------------------------------------------------------------
// 関数： Jiro_GetFileSizeString
// 機能 : ファイルサイズ文字列を取得
// add_igari 070220
//-------------------------------------------------------------
void Jiro_GetFileSizeString( long inFileSize, char* outFileSizeStr );

//-------------------------------------------------------------
// 関数 : Jiro_MakeVersionString 
// 機能 : バージョン文字列を作成
// inComma = カンマ数（０、１，２）、それ以外はすべての桁
// add_hisa 070220
//-------------------------------------------------------------
void Jiro_MakeVersionString( const char* inValue, long inComma, char* outVersion );

//-------------------------------------------------------------
// 関数 : Jiro_Strcmp
// 機能 : 大文字小文字を区別せずに文字列を比較する
// メモ : strcasecmpがwindowsにないので、自前で実装
// add tamura 070828
//-------------------------------------------------------------
long Jiro_Strcmp( const char* s1, const char* s2 );

//-------------------------------------------------------------
// 関数 : Jiro_ConvertSecToDateString
// 機能 : 秒数を日付に変換する
// sugimoto 080606
//-------------------------------------------------------------
void Jiro_ConvertSecToDateString( unsigned long inSec, char* outTimeStr );

//-------------------------------------------------------------
// 関数 : Jiro_rindex
// 機能 : 全角の混じった文字列から指定した半角文字が最後に出てくる位置を返す
// シフトＪＩＳ限定
// add tamura 080606
//-------------------------------------------------------------
char* Jiro_rindex( const char* inStr, char inChar );

//-------------------------------------------------------------
// 関数 : Jiro_index
// 機能 : 全角の混じった文字列から指定した半角文字が最初に出てくる位置を返す
// シフトＪＩＳ限定
// add tamura 080606
//-------------------------------------------------------------
char* Jiro_index( const char* inStr, char inChar );

//-------------------------------------------------------------
// 関数 : Jiro_Strcasestr
// 機能 : 部分文字列が文字列中で最初に現れる位置を見つける（両方の引数に対して大文字小文字を無視）
// add tamura 080606
//-------------------------------------------------------------
const char* Jiro_Strcasestr( const char* inHaystack, const char* inNeedle );

//-------------------------------------------------------------
// 関数： Jiro_GetStringLength
// 機能 : 全角半角を考慮して「文字数（日本語の”あ”を２バイトではなく１文字と判定）」を取得
// add_hisa 090513
//-------------------------------------------------------------
long Jiro_GetStringLength( const char* inStr );

//-------------------------------------------------------------
// 関数 : Jiro_GetTextEncoding
// 機能 : 文字エンコーディングを取得
// add_hisa 090730
//-------------------------------------------------------------
bool Jiro_GetTextEncoding( const char* inTextData, long inTextDataSize, char* outEncoding );
	
#ifdef __cplusplus
}
#endif

#endif
