// TYPE: C
// PRJ: JCL
// PGM: Jiro_TAB
// VER: 1.20
// USES: CodeWarrior
// CREATE: 1999/02/21( Shiratori )
// UPDATE: 2000/06/02( Shiratori )
// UPDATE: 2007/04/02( tamura )
// UPDATE: 2009/03/16( igari, tamura )
/////////////////////////////////////////////////////
// 000602 - ＭＳ-ＤＯＳ形式の改行にも対応
// 070402 - Linux版(CR/LF/CRLFに対応)
#ifndef __JIRO_TAB__
#define __JIRO_TAB__

//***********************************************************
// 構造体
//***********************************************************
typedef struct JIRO_TAB
{
	char * 	textPtr;		// TABデータバッファ(NULL Terminate)
	char * 	textEndPos;		// バッファの最終位置
	bool	isCountEmpRow;	// 空行も数える？
	char * 	currentRowPos;	// 現在の行の開始位置
} JIRO_TAB;

#ifdef __cplusplus
extern "C" {
#endif

//***********************************************************
// 外部関数のプロトタイプ宣言
//***********************************************************
// -------------------------------------------------
// 関数 : Jiro_TAB_Init
// 機能 : TAB テーブルの初期化
// outTabTblPtr (out) : TAB テーブル
// textPtr (in) : TAB データが入っている文字列
// -------------------------------------------------
void Jiro_TAB_Init( JIRO_TAB* outTabTblPtr, char* inTextPtr );

// -------------------------------------------------
// 関数 : Jiro_TAB_GetRowCount
// 機能 : 行数を取得
// inTabTblPtr (in) : TAB テーブル
// 戻値: 行数
// mod_tamura 090316 CR/LF/CRLFに対応
//--------------------------------------------------
long Jiro_TAB_GetRowCount( JIRO_TAB * inTabTblPtr );

// -------------------------------------------------
// 関数 : Jiro_TAB_FirstRow
// 機能 : 先頭行に移動
// inTabTblPtr (in) : TAB テーブル
// 戻値:true( 先頭行に移動成功)、false( 先頭行がない)
// -------------------------------------------------
bool Jiro_TAB_FirstRow( JIRO_TAB* ioTabTblPtr );

// -------------------------------------------------
// 関数 : Jiro_TAB_NextRow
// 機能 : 次の行に移動
// inTabTblPtr (in) : TAB テーブル
// 戻値:true( 次行に移動成功)、false( 次行がない)
// -------------------------------------------------
bool Jiro_TAB_NextRow( JIRO_TAB* ioTabTblPtr );

// -------------------------------------------------
// 関数 : Jiro_TAB_GetFieldSize
// 機能 : 現在の行の指定された列のデータサイズを取得する。
// inTabTblPtr (in) : TAB テーブル
// column (in) : 取得したいフィールドの番号(0 はじまり)
// 戻値: データサイズ
// -------------------------------------------------
long Jiro_TAB_GetFieldSize( JIRO_TAB* inTabTblPtr, long inColumn );

// -------------------------------------------------
// 関数 : Jiro_TAB_GetFieldData
// 機能 : 現在の行の指定された列のデータを取得する。
// inTabTblPtr (in) : TAB テーブル
// column (in) : 取得したいフィールドの番号(0 はじまり)
// bufLength (out) : フィールドの値のサイズ
// outBufPtr (out) : フィールドの値
// -------------------------------------------------
bool Jiro_TAB_GetFieldData( JIRO_TAB* inTabTblPtr, long inColumn, long inBufLength, char* outBufPtr );

// -------------------------------------------------
// 関数 : Jiro_TAB_GetNumOfColumns
// 機能 : 現在の行の列数を取得
// add_igari 090316
// -------------------------------------------------
long Jiro_TAB_GetNumOfColumns( JIRO_TAB * inTabTblPtr );

//--------------------------------------------------
// 関数 : Jiro_TAB_GetFieldLongValue
// 機能 : 現在の行の指定された列のフィールドロング値を取得
// add_hisa 090316
//--------------------------------------------------
long Jiro_TAB_GetFieldLongValue( JIRO_TAB * inTabTblPtr, long inColumn );

//--------------------------------------------------
// 関数 : Jiro_TAB_GetFieldDoubleValue
// 機能 : 現在の行の指定された列のフィールドダブル値を取得
// add_igari 090316
//--------------------------------------------------
double Jiro_TAB_GetFieldDoubleValue( JIRO_TAB * inTabTblPtr, long inColumn );

#ifdef __cplusplus
}
#endif

#endif
